<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from cookbook.texi on 28 April 1999 -->

<TITLE>The SUIF COOKBOOK - Example 3</TITLE>
<link href="cookbook_5.html" rel=Next>
<link href="cookbook_3.html" rel=Previous>
<link href="cookbook_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="cookbook_1.html">first</A>, <A HREF="cookbook_3.html">previous</A>, <A HREF="cookbook_5.html">next</A>, <A HREF="cookbook_8.html">last</A> section, <A HREF="cookbook_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC15" HREF="cookbook_toc.html#TOC15">Example 3 - Print Array Accesses</A></H1>

<P>
In this example all the array accesses are printed in a given order.
For each outermost loop nest, all the array acceses inside the body of
that loops are printed. Accesses that are written (LHS) and read (RHS) are
printed separately.

</P>


<H2><A NAME="SEC16" HREF="cookbook_toc.html#TOC16">prog3.cc</A></H2>

<PRE>
#include &#60;stdlib.h&#62;
#include &#60;suif1.h&#62;
#include &#60;useful.h&#62;
#include &#60;dependence.h&#62;

/***************************************************************************
 * Declare a new class which is a list of "in_array"'s                     *
 ***************************************************************************/
DECLARE_DLIST_CLASS(array_instr_list, in_array *);

void find_array_instr(tree_node_list * tnl, array_instr_list * ail);
void find_array_instr(tree_node * tn, array_instr_list * ail);
void find_array_instr(instruction * i, array_instr_list * ail);

/***************************************************************************
 * Iterate over all the elements in the list and print each instruction.   *
 * The call to print_array_access which is defined in dependence/dodep.h,  *
 * will print the access in a C-like format.                               * 
 ***************************************************************************/
void print_array_instr_list(array_instr_list * ail) 
{
    array_instr_list_iter iter(ail);
    while(!iter.is_empty()) {
        in_array * ai = iter.step();
        print_array_access(ai);
    }
}

/***************************************************************************
 * Iterate over all the array accesses and seperate them in to two lists,  *
 * LHS in one and RHS in other.  The function is_lhs is defined in         *
 * useful.h  Then print the LHS and RHS accesses seperately.               *
 ***************************************************************************/
void process_array_instr_list(array_instr_list * ail) 
{
    array_instr_list lhs_list;
    array_instr_list rhs_list;
    array_instr_list_iter iter(ail);
    while(!iter.is_empty()) {
        in_array * ai = iter.step();
        if(is_lhs(ai)) 
            lhs_list.append(ai);
        else
            rhs_list.append(ai);
    }

    printf("LHS:\n");
    print_array_instr_list(&#38;lhs_list);
    printf("RHS:\n");
    print_array_instr_list(&#38;rhs_list);
}

/***************************************************************************
 * The main iterator over structured control-flow.                         *
 * When there is no outer for loop ail will be NULL.  ail will be assigned *
 * at the outermost for loops. All the array accesses are collected and    *
 * print routine is called at the outermost for loop.                      *
 ***************************************************************************/
void find_array_instr(tree_node_list * tnl, array_instr_list * ail)
{
    tree_node_list_iter iter(tnl);
    while(!iter.is_empty()) {
        tree_node * tn = iter.step();
        
        switch(tn-&#62;kind()) {
        case TREE_FOR:
            tree_for * tnf = (tree_for *)tn;
            find_array_instr(tnf-&#62;lb_list(), ail);
            find_array_instr(tnf-&#62;ub_list(), ail);
            find_array_instr(tnf-&#62;step_list(), ail);
            
            boolean outermost = FALSE;
            array_instr_list * ail_bdy = ail;
            if(ail_bdy == NULL) {
                outermost = TRUE;
                ail_bdy = new array_instr_list;
            }
            printf("For loop %s %s\n", 
                   tnf-&#62;index()-&#62;name(), 
                   outermost?"(Outermost)":"");
            
            find_array_instr(tnf-&#62;landing_pad(), ail_bdy);
            find_array_instr(tnf-&#62;body(), ail_bdy);
            
            if(outermost) process_array_instr_list(ail_bdy);
            break;
            
        case TREE_IF:
            tree_if * tni = (tree_if *)tn;
            find_array_instr(tni-&#62;header(), ail);
            find_array_instr(tni-&#62;then_part(), ail);
            find_array_instr(tni-&#62;else_part(), ail);
            break;
            
        case TREE_LOOP:
            tree_loop * tnl = (tree_loop *)tn;
            find_array_instr(tnl-&#62;body(), ail);
            find_array_instr(tnl-&#62;test(), ail);
            break;
            
        case TREE_BLOCK:
            tree_block * tnb = (tree_block *)tn;
            find_array_instr(tnb-&#62;body(), ail);
            break;
            
        case TREE_INSTR:
            tree_instr * tnin = (tree_instr *)tn;
            if(ail)
                find_array_instr(tnin-&#62;instr(), ail);
            break;
            
        default:
            assert(0);
            break;
        }
    }
}

/***************************************************************************
 * Iterate over all the instructions of expression trees, add array        *
 * instructions to the list.                                               *
 ***************************************************************************/
void find_array_instr(instruction * ins, array_instr_list * ail)
{
    if(ins-&#62;opcode() == io_array) {
        assert(ail);
        in_array * ia = (in_array *)ins;
        ail-&#62;append(ia);
    }

    for(int i=0; i&#60;ins-&#62;num_srcs(); i++) {
        operand op(ins-&#62;src_op(i));
        if(op.is_instr())
            find_array_instr(op.instr(), ail);
    }
}

/***************************************************************************
 * Start processing..                                                      *
 ***************************************************************************/
void do_proc(tree_proc * tp)
{
    proc_sym * psym = tp-&#62;proc();
    printf("=======%s======= \n", psym-&#62;name());
    find_array_instr(tp-&#62;body(), NULL);
}

/***************************************************************************
 * Initialize and iterate over all the procedures.                         *
 ***************************************************************************/
main(int argc, char * argv[])
{
    start_suif(argc, argv);
    suif_proc_iter(argc, argv, do_proc);
}
</PRE>

<P>
<A NAME="IDX42"></A>
<A NAME="IDX43"></A>
<A NAME="IDX44"></A>
<A NAME="IDX45"></A>
<A NAME="IDX46"></A>
<A NAME="IDX47"></A>
<A NAME="IDX48"></A>
<A NAME="IDX49"></A>
<A NAME="IDX50"></A>
<A NAME="IDX51"></A>
<A NAME="IDX52"></A>
<A NAME="IDX53"></A>
<A NAME="IDX54"></A>
<A NAME="IDX55"></A>
<A NAME="IDX56"></A>
<A NAME="IDX57"></A>
<A NAME="IDX58"></A>
<A NAME="IDX59"></A>
<A NAME="IDX60"></A>
<A NAME="IDX61"></A>
<A NAME="IDX62"></A>
<A NAME="IDX63"></A>
<A NAME="IDX64"></A>
<A NAME="IDX65"></A>
<A NAME="IDX66"></A>
<A NAME="IDX67"></A>
<A NAME="IDX68"></A>
<A NAME="IDX69"></A>
<A NAME="IDX70"></A>
<A NAME="IDX71"></A>
<A NAME="IDX72"></A>
<A NAME="IDX73"></A>
<A NAME="IDX74"></A>
<A NAME="IDX75"></A>
<A NAME="IDX76"></A>
<A NAME="IDX77"></A>
<A NAME="IDX78"></A>
<A NAME="IDX79"></A>
<A NAME="IDX80"></A>
<A NAME="IDX81"></A>
<A NAME="IDX82"></A>
<A NAME="IDX83"></A>
<A NAME="IDX84"></A>
<A NAME="IDX85"></A>
<A NAME="IDX86"></A>
<A NAME="IDX87"></A>
<A NAME="IDX88"></A>
<A NAME="IDX89"></A>
<A NAME="IDX90"></A>
<A NAME="IDX91"></A>
<A NAME="IDX92"></A>
<A NAME="IDX93"></A>
<A NAME="IDX94"></A>
<A NAME="IDX95"></A>
<A NAME="IDX96"></A>
<A NAME="IDX97"></A>
<A NAME="IDX98"></A>
<A NAME="IDX99"></A>
<A NAME="IDX100"></A>

</P>
<P>
<A NAME="IDX101"></A>
<A NAME="IDX102"></A>
<A NAME="IDX103"></A>
<A NAME="IDX104"></A>
<A NAME="IDX105"></A>
<A NAME="IDX106"></A>
<A NAME="IDX107"></A>
<A NAME="IDX108"></A>

</P>


<H2><A NAME="SEC17" HREF="cookbook_toc.html#TOC17">Makefile</A></H2>

<PRE>
TARGET = prog3
LIBS =		-ldependence -lsuifmath -lbuilder -luseful -lsuif1 -lm
SRCS =		prog3.cc
OBJS =		prog3.o

all:		prog3
install-bin:	install-prog

include $(SUIFHOME)/Makefile.std
</PRE>



<H2><A NAME="SEC18" HREF="cookbook_toc.html#TOC18">Testing the pass</A></H2>
<P>
Let's use the following input file:

</P>


<H3><A NAME="SEC19" HREF="cookbook_toc.html#TOC19">input3.c</A></H3>

<PRE>
double A[10000];
double B[100][100];

test1(int IU, int JU, int KU)
{
    int i, j, k;
    for(i=0; i&#60;IU; i++) 
        for(j=0; j&#60;JU; j++) {
            for(k=8; k&#60;KU; k++) 
                A[k] = A[k-8];
            B[i][j] = B[i+1][j] + A[i];
        }
    for(i=0; i&#60;IU; i++) 
        for(j=0; j&#60;JU; j++) 
            B[i][j] = B[i][j] + B[i+1][j];
}

test2( int KU)
{
    int  k;

    for(k=8; k&#60;KU; k++) 
        A[k] = A[1] + A[k] + A[k-8];
}
</PRE>



<H3><A NAME="SEC20" HREF="cookbook_toc.html#TOC20">Test session</A></H3>

<PRE>
csh&#62; prog3 input3.spd
=======test1=======
For loop i (Outermost)
For loop j
For loop k
LHS:
A[k]
B[i,j]
RHS:
A[k-8]
B[i+1,j]
A[i]
For loop i (Outermost)
For loop j
LHS:
B[i,j]
RHS:
B[i,j]
B[i+1,j]
=======test2=======
For loop k (Outermost)
LHS:
A[k]
RHS:
A[1]
A[k]
A[k-8]
csh&#62;
</PRE>

<P><HR><P>
<p>Go to the <A HREF="cookbook_1.html">first</A>, <A HREF="cookbook_3.html">previous</A>, <A HREF="cookbook_5.html">next</A>, <A HREF="cookbook_8.html">last</A> section, <A HREF="cookbook_toc.html">table of contents</A>.
</BODY>
</HTML>
